    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class is derived from <em>Attribute</em> and represents a reference
    62   * to the source file of this class.  At most one SourceFile attribute
    63   * should appear per classfile.  The intention of this class is that it is
    64   * instantiated from the <em>Attribute.readAttribute()</em> method.
    65   *
    66   * @version $Id: SourceFile.java,v 1.3 2002/03/11 16:16:35 mdahm Exp $
    67   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    68   * @see     Attribute
    69   */
    70  public final class SourceFile extends Attribute {
    71    private int sourcefile_index;
    72
    73    /***
    74     * Initialize from another object. Note that both objects use the same
    75     * references (shallow copy). Use clone() for a physical copy.
    76     */
    77    public SourceFile(SourceFile c) {
    78      this(c.getNameIndex(), c.getLength(), c.getSourceFileIndex(),
    79  	 c.getConstantPool());
    80    }
    81
    82    /***
    83     * Construct object from file stream.
    84     * @param name_index Index in constant pool to CONSTANT_Utf8
    85     * @param length Content length in bytes
    86     * @param file Input stream
    87     * @param constant_pool Array of constants
    88     * @throws IOException
    89     */
    90    SourceFile(int name_index, int length, DataInputStream file,
    91  	     ConstantPool constant_pool) throws IOException
    92    {
    93      this(name_index, length, file.readUnsignedShort(), constant_pool);
    94    }
    95
    96    /***
    97     * @param name_index Index in constant pool to CONSTANT_Utf8, which
    98     * should represent the string "SourceFile".
    99     * @param length Content length in bytes, the value should be 2.
    100    * @param constant_pool The constant pool that this attribute is
    101    * associated with.
    102    * @param sourcefile_index Index in constant pool to CONSTANT_Utf8.  This
    103    * string will be interpreted as the name of the file from which this
    104    * class was compiled.  It will not be interpreted as indicating the name
    105    * of the directory contqining the file or an absolute path; this
    106    * information has to be supplied the consumer of this attribute - in
    107    * many cases, the JVM.
    108    */
    109   public SourceFile(int name_index, int length, int sourcefile_index,
    110 		    ConstantPool constant_pool)
    111   {
    112     super(Constants.ATTR_SOURCE_FILE, name_index, length, constant_pool);
    113     this.sourcefile_index = sourcefile_index;
    114   }
    115
    116   /***
    117    * Called by objects that are traversing the nodes of the tree implicitely
    118    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    119    * fields, attributes, etc. spawns a tree of objects.
    120    *
    121    * @param v Visitor object
    122    */
    123   public void accept(Visitor v) {
    124     v.visitSourceFile(this);
    125   }
    126
    127   /***
    128    * Dump source file attribute to file stream in binary format.
    129    *
    130    * @param file Output file stream
    131    * @throws IOException
    132    */
    133   public final void dump(DataOutputStream file) throws IOException
    134   {
    135     super.dump(file);
    136     file.writeShort(sourcefile_index);
    137   }
    138
    139   /***
    140    * @return Index in constant pool of source file name.
    141    */
    142   public final int getSourceFileIndex() { return sourcefile_index; }
    143
    144   /***
    145    * @param sourcefile_index.
    146    */
    147   public final void setSourceFileIndex(int sourcefile_index) {
    148     this.sourcefile_index = sourcefile_index;
    149   }
    150
    151   /***
    152    * @return Source file name.
    153    */
    154   public final String getSourceFileName() {
    155     ConstantUtf8 c = (ConstantUtf8)constant_pool.getConstant(sourcefile_index,
    156 							     Constants.CONSTANT_Utf8);
    157     return c.getBytes();
    158   }
    159
    160   /***
    161    * @return String representation
    162    */
    163   public final String toString() {
    164     return "SourceFile(" + getSourceFileName() + ")";
    165   }
    166
    167   /***
    168    * @return deep copy of this attribute
    169    */
    170   public Attribute copy(ConstantPool constant_pool) {
    171     return (SourceFile)clone();
    172   }
    173 }

This page was automatically generated by Maven